<template>
  <div class="error-message-container">
    <div class="error-message-popup">
      <div class="error-message-popup-body">
        <h2>{{errorMessage.title}}</h2>
        <p>{{errorMessage.description}}</p>
      </div>
      <div class="error-message-popup-footer">
        <input type="button" value="OK" v-on:click="closePopup()">
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import Vue from 'vue'
import { mapState } from 'vuex'
import store from '../../store/store'

export default Vue.extend({
  computed: {
    ...mapState([
      'errorMessage',
    ])
  },
  methods: {
    closePopup() {
      store.commit('setErrorMessage', undefined);
    }
  },
});
</script>

<style lang="scss">
@import "../../style/vars.scss";

.error-message-container {
  position: fixed;
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
  background: #0005;
  display: flex;
  justify-content: center;
  align-items: center;
  z-index: 1000;
  animation: error-message-container-appear 0.5s;
  .error-message-popup {
    background: white;
    border-radius: 10px;
    box-shadow: 0 10px 10px #0005;
    overflow: hidden;
    animation: error-message-popup-appear 0.5s;
    position: relative;
    .error-message-popup-body {
      padding: 30px;
      h2 {
        color: #333;
      }
      p {
        color: #333;
      }
    }
    .error-message-popup-footer {
      padding: 30px;
      text-align: right;
      background-color: $vlue-color-delete;
      background-size: 30px;
      background-image: url('../../../public/core/images/stripePattern.png');
      input {
        background: $vlue-dev-bg-color-dark;
        border: none;
        padding: 10px 50px;
        border-radius: 5px;
        color: white;
        font-weight: bold;
        transition: 0.25s;
        &:hover {
          margin: -5px 0 5px 0;
          box-shadow: 0 5px 5px #0005;
          filter: brightness(1.5);
        }
        &:active {
          transition: 0s;
          margin: 0;
          box-shadow: none;
          filter: brightness(1);
        }
      }
    }
  }
}

@keyframes error-message-container-appear {
  from {
    opacity: 0;
  }
  to {
    opacity: 1;
  }
}

@keyframes error-message-popup-appear {
  from {
    top: 10px;
    opacity: 0;
  }
  to {
    top: 0;
    opacity: 1;
  }
}
</style>
